﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SQLite;

namespace Envelope_Index_Browser
{
    public partial class NotesDbBrowser : Form
    {
        public NotesDbBrowser()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            OpenFileDialog file = new OpenFileDialog();
            file.ShowDialog();

            if (file.FileName != "")
            {
                dir.Text = file.FileName;
                ShowMsgs();
            }
        }

        private void ShowMsgs()
        {
            text.Text = "";

            DataTable msgs = new DataTable();
            msgs.Columns.Add("ROWID", typeof(Int32));
            msgs.Columns.Add("title", typeof(String));
            msgs.Columns.Add("summary", typeof(String));
            msgs.Columns.Add("creation_date", typeof(Int32));

            SQLiteConnection sql = new SQLiteConnection("Data Source=" + dir.Text);
            sql.Open();

            SQLiteCommand cmd = sql.CreateCommand();
            cmd.CommandText = "SELECT ROWID, title, summary, creation_date FROM Note ORDER BY ROWID";

            using (SQLiteDataReader reader = cmd.ExecuteReader())
            {
                while (reader.Read())
                {
                    DataRow row = msgs.NewRow();

                    row["ROWID"] = Int32.Parse(reader[0].ToString());
                    row["title"] = reader[1].ToString();
                    row["summary"] = reader[2].ToString();
                    row["creation_date"] = Int32.Parse(reader[3].ToString());

                    msgs.Rows.Add(row);
                }
            }

            sql.Close();

            messages.DataSource = msgs;
        }

        private void messages_SelectionChanged(object sender, EventArgs e)
        {
/*
messages
ROWID*, sender, subject, _to, cc, date_sent, date_received

message_data
message_id*, data
    */
            text.Text = "";
            try
            {
                string id = messages.CurrentRow.Cells["ROWID"].Value.ToString();
                if (id != "")
                {
                    SQLiteConnection sql = new SQLiteConnection("Data Source=" + dir.Text);
                    sql.Open();

                    SQLiteCommand cmd = sql.CreateCommand();
                    cmd.CommandText = "SELECT note_id, data FROM note_bodies WHERE note_id = " + id;

                    using (SQLiteDataReader reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            text.Text = reader[1].ToString();
                            
                            if (parse.Checked)
                                text.Text = text.Text.Replace("<br class=\"webkit-block-placeholder\">", "").Replace("</div>", "").Replace("<div>", "\n").Replace("&amp;", "&");
                        }
                    }

                    sql.Close();
                }
            }
            catch { }
        }

        private void update_Click(object sender, EventArgs e)
        {
            text.Text = text.Text.Replace("&", "&amp;");
            text.Text = text.Text.Replace("\n", "</div><div>");
            text.Text = text.Text.Replace("<div></div>", "<div><br class=\"webkit-block-placeholder\"></div>");

            if (text.Text.IndexOf("</div>") != -1)
            {
                string temp = text.Text;
                text.Text = temp.Substring(0, temp.IndexOf("</div>"));
                text.Text = text.Text + temp.Substring(temp.IndexOf("</div>") + 6, temp.Length - 6 - temp.IndexOf("</div>"));
            }

            if (text.Text.IndexOf("<div>") != -1)
                text.Text = text.Text + "</div>";

            text.Text = text.Text.Replace("<div></div>", "<div><br class=\"webkit-block-placeholder\"></div>");

            try
            {
                string id = messages.CurrentRow.Cells["ROWID"].Value.ToString();
                if (id != "")
                {
                    SQLiteConnection sql = new SQLiteConnection("Data Source=" + dir.Text);
                    sql.Open();

                    SQLiteCommand cmd = sql.CreateCommand();
                    cmd.CommandText = "UPDATE note_bodies SET data = '" + text.Text.Replace("'", "''") + "' WHERE note_id = " + id;
                    cmd.ExecuteNonQuery();

                    sql.Close();

                    MessageBox.Show("Done");
                    messages_SelectionChanged(Type.Missing, EventArgs.Empty);
                }
            }
            catch { }
        }
    }
}
